# Define the kmod package name here.
%define kmod_name zio

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion 3.10.0-514.el7.%{_target_cpu}}

Name:    %{kmod_name}-kmod
Version: 0.0
Release: 3%{?dist}
Group:   System Environment/Kernel
License: GPLv2
Summary: %{kmod_name} kernel module(s)
URL:     http://www.ohwr.org/projects/zio

BuildRequires: perl git emacs texinfo texinfo-tex
BuildRequires: redhat-rpm-config
ExclusiveArch: x86_64

# Sources.
Source0:  %{kmod_name}-%{version}.tar.bz2
Source5:  GPL-v2.0.txt
Source10: kmodtool-%{kmod_name}-el7.sh

# Magic hidden here.
%{expand:%(sh %{SOURCE10} rpmtemplate %{kmod_name} %{kversion} "")}

# Disable the building of the debug package(s).
%define debug_package %{nil}

%description
This package provides the %{kmod_name} kernel module(s).
It is built to depend upon the specific ABI provided by a range of releases
of the same variant of the Linux kernel and not on any one specific build.

%package headers
Summary:	header files for %{kmod_name}-%{version}
BuildArch:	noarch

%description headers
Provides the %{kmod_name} kernel headers.

%package tools
Summary:        tools for %{kmod_name}-%{version}

%description tools
Provides the %{kmod_name} kernel module tools.

%prep
%setup -q -n %{kmod_name}-%{version}
echo "override zio * weak-updates/%{kmod_name}" > kmod-%{kmod_name}.conf
echo "override zio-buf-vmalloc * weak-updates/%{kmod_name}" >> kmod-%{kmod_name}.conf
echo "override zio-ad788 * weak-updates/%{kmod_name}"       >> kmod-%{kmod_name}.conf
echo "override zio-fake-dtc * weak-updates/%{kmod_name}"    >> kmod-%{kmod_name}.conf
echo "override zio-gpio * weak-updates/%{kmod_name}"        >> kmod-%{kmod_name}.conf
echo "override zio-irq-tdc * weak-updates/%{kmod_name}"     >> kmod-%{kmod_name}.conf
echo "override zio-loop * weak-updates/%{kmod_name}"        >> kmod-%{kmod_name}.conf
echo "override zio-mini * weak-updates/%{kmod_name}"        >> kmod-%{kmod_name}.conf
echo "override zio-vmk8055 * weak-updates/%{kmod_name}"     >> kmod-%{kmod_name}.conf
echo "override zio-zero * weak-updates/%{kmod_name}"        >> kmod-%{kmod_name}.conf
echo "override zio-trig-hrt * weak-updates/%{kmod_name}"    >> kmod-%{kmod_name}.conf
echo "override zio-trig-irq * weak-updates/%{kmod_name}"    >> kmod-%{kmod_name}.conf
echo "override zio-trig-timer * weak-updates/%{kmod_name}"  >> kmod-%{kmod_name}.conf

%build
%{__make} %{?_smp_mflags} LINUX=%{_usrsrc}/kernels/%{kversion}

cd doc
%{__make}
cd ..

%install
%{__install} -d %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/

%{__install} buffers/zio-buf-vmalloc.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} drivers/zio-ad788x.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} drivers/zio-fake-dtc.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} drivers/zio-gpio.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} drivers/zio-irq-tdc.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} drivers/zio-loop.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} drivers/zio-mini.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} drivers/zio-vmk8055.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} drivers/zio-zero.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} triggers/zio-trig-hrt.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} triggers/zio-trig-irq.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} triggers/zio-trig-timer.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} zio.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/

%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} -d %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} %{SOURCE5} %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/

# strip the modules(s)
find %{buildroot} -type f -name \*.ko -exec %{__strip} --strip-debug \{\} \;

# Sign the modules(s)
%if %{?_with_modsign:1}%{!?_with_modsign:0}
# If the module signing keys are not defined, define them here.
%{!?privkey: %define privkey %{_sysconfdir}/pki/SECURE-BOOT-KEY.priv}
%{!?pubkey: %define pubkey %{_sysconfdir}/pki/SECURE-BOOT-KEY.der}
for module in $(find %{buildroot} -type f -name \*.ko);
do %{__perl} /usr/src/kernels/%{kversion}/scripts/sign-file \
sha256 %{privkey} %{pubkey} $module;
done
%endif

# Install headers
%{__install} -d %{buildroot}%{_usrsrc}/kernels/
%{__install} -d %{buildroot}%{_usrsrc}/kmods/%{kmod_name}-%{version}/linux
%{__cp} include/linux/* %{buildroot}%{_usrsrc}/kmods/%{kmod_name}-%{version}/linux

# Install tools
%{__install} -d %{buildroot}%{_libexecdir}/%{kmod_name}/
%{__install} tools/test-dtc %{buildroot}%{_libexecdir}/%{kmod_name}/
%{__install} tools/zio-cat-file %{buildroot}%{_libexecdir}/%{kmod_name}/
%{__install} tools/zio-dump %{buildroot}%{_libexecdir}/%{kmod_name}/

# Install infopage
%{__install} -d %{buildroot}%{_infodir}
%{__install} doc/zio-manual.info %{buildroot}%{_infodir}/

# Install docs
%{__install} doc/zio-manual.txt %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__cp} -r Documentation/ABI %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/

%clean
%{__rm} -rf %{buildroot}

%files headers
%defattr(0644,root,root,0755)
%{_usrsrc}/kmods/%{kmod_name}-%{version}

%files tools
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_libexecdir}/%{kmod_name}/*
%{_infodir}/*

%changelog
* Thu Jun 29 2017 Akemi Yagi <toracat@elrepo.org> - 0.0-3
-Initial build for el7.
